library stdbisapi;

{ Wichtiger Hinweis zur DLL-Speicherverwaltung: Sharemem mu die erste
 Unit in der uses-Klausel Ihrer Bibliothek und Ihres Projekts sein,
 wenn Ihre DLL Prozeduren und Funktionen exportiert, die
 Strings als Parameter oder Funktionsergebnisse bergeben. Dies
 betrifft alle Strings, die an Ihre DLL oder von Ihrer DLL bergeben werden--selbst diejenigen,
 die sich in Records oder Klassen befinden. Sharemem ist die Schnittstelle zu
 BORLNDMM.DLL, die den gemeinsamen Zugriff auf den Speicher verwaltet; DELPHIMM.DLL
 mu mit Ihrer DLL weitergegeben werden. Wenn Sie BORLNDMM.DLL nicht verwenden mchten, mssen
 Strings als PChar oder ShortString bergeben werden.}

uses
  SysUtils,
  Classes,
  windows,
  Isapi,
  ADODB_TLB in '..\..\..\..\programm.ing\borland\delphi4\lib\ADODB_TLB.pas',
  IsapiHlp in 'IsapiHlp.pas',
  operationen in 'operationen.pas';

function GetExtensionVersion(var Ver: THSE_VERSION_INFO): BOOL; stdcall;
begin
 Ver.dwExtensionVersion := MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
 Ver.lpszExtensionDesc := 'StarTrek-Datenbank-ISAPI';
 ConnectionString := '';
 GetExtensionVersion := true;
end;

function HttpExtensionProc(var ECB: TEXTENSION_CONTROL_BLOCK): DWORD; stdcall;
var ResStr : String;
    StrLen : DWORD;
    dbergstring : String;
    ParameterListe : TStringList;
begin
 ECB.lpszLogData := 'StarTrek-Datenbank-ISAPI';
 IsapiHlp.pECB := @ECB;
 dbergstring := 'Test';
 ParameterListe := TStringList.Create;
 if StrPas(ECBMethod) = 'POST' then
  begin
   GetContentData(ParameterListe);
   if ParameterListe.Values['Kommando'] = 'Anmelden' then
    begin
     ResStr := Anmelden(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonAendern' then
    begin
     ResStr := PersonAendernSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonAendernSpeichern' then
    begin
     ResStr := PersonAendernSpeichern(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonHinzufuegen' then
    begin
     ResStr := PersonHinzufuegenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonHinzufuegenSpeichern' then
    begin
     ResStr := PersonHinzufuegenSpeichern(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonSuchen' then
    begin
     ResStr := PersonSuchenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetAendern' then
    begin
     ResStr := PlanetAendernSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetAendernSpeichern' then
    begin
     ResStr := PlanetAendernSpeichern(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetHinzufuegen' then
    begin
     ResStr := PlanetHinzufuegenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetHinzufuegenSpeichern' then
    begin
     ResStr := PlanetHinzufuegenSpeichern(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetSuchen' then
    begin
     ResStr := PlanetSuchenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'RasseAendern' then
    begin
     ResStr := RasseAendernSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'RasseHinzufuegen' then
    begin
     ResStr := RasseHinzufuegenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'RasseSuchen' then
    begin
     ResStr := RasseSuchenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'SchiffAendern' then
    begin
     ResStr := SchiffAendernSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'SchiffHinzufuegen' then
    begin
     ResStr := SchiffHinzufuegenSuchen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'SchiffSuchen' then
    begin
     ResStr := SchiffSuchenSuchen(ParameterListe);
    end;
  end;
 if StrPas(ECBMethod) = 'GET' then
  begin
   GetQueryStringData(ParameterListe);
   if ParameterListe.Values['Kommando'] = 'Anmelden' then
    begin
     ResStr := Anmelden(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'Abmelden' then
    begin
     ResStr := Abmelden;
    end;
   if ParameterListe.Values['Kommando'] = 'PersonAendernAuswaehlen' then
    begin
     ResStr := PersonAendernAuswaehlen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PersonSuchenAuswaehlen' then
    begin
     ResStr := PersonSuchenAuswaehlen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetAendernAuswaehlen' then
    begin
     ResStr := PlanetAendernAuswaehlen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'PlanetSuchenAuswaehlen' then
    begin
     ResStr := PlanetSuchenAuswaehlen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'RasseSuchenAuswaehlen' then
    begin
     ResStr := RasseSuchenAuswaehlen(ParameterListe);
    end;
   if ParameterListe.Values['Kommando'] = 'SchiffSuchenAuswaehlen' then
    begin
     ResStr := SchiffSuchenAuswaehlen(ParameterListe);
    end;
  end;
 ResStr := Format('HTTP/1.0 200 OK'#13#10'Content-Type: text/html'#13#10 +
                  'Content-Length: %d'#13#10'Content:'#13#10#13#10'%s',
                  [Length(ResStr), ResStr]);
 StrLen := Length(ResStr);
 ECB.dwHTTPStatusCode := 200;
 ECB.WriteClient(ECB.ConnID, Pointer(ResStr), StrLen, 0);
 Parameterliste.Free;
 HttpExtensionProc := HSE_STATUS_SUCCESS;
end;

exports GetExtensionVersion, HttpExtensionProc;

begin
end.
